diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 3bb772159..f09a5eb67 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -21,10 +21,13 @@ import net.minecraft.client.render.worldtype.WorldTypeFX;
 import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemDiscMusic;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
@@ -1433,17 +1436,350 @@ public class RenderGlobal
             if(hitResult.hitType == HitResult.HitType.TILE)
             {
                 float expand = 0.002F;
-                int j = world.getBlockId(hitResult.x, hitResult.y, hitResult.z);
-                if(j > 0)
+                Block<?> block = world.getBlock(hitResult.x, hitResult.y, hitResult.z);
+                if(block != null)
                 {
-                    BoundingVolume volume = Blocks.blocksList[j].getBoundingVolume(world, hitResult.x, hitResult.y, hitResult.z);
+                    BoundingVolume volume = block.getBoundingVolume(world, hitResult.x, hitResult.y, hitResult.z);
                     if (volume != null)
                     {
                         drawOutlinedVolume(volume, hitResult.x - offsetX, hitResult.y - offsetY, hitResult.z - offsetZ, expand);
                     }
                     else
                     {
-                        drawOutlinedBoundingBox(Blocks.blocksList[j].getSelectedBoundingBoxFromPool(world, hitResult.x, hitResult.y, hitResult.z).grow(expand, expand, expand).cloneMove(-offsetX, -offsetY, -offsetZ));
+                        drawOutlinedBoundingBox(block.getSelectedBoundingBoxFromPool(world, hitResult.x, hitResult.y, hitResult.z).grow(expand, expand, expand).cloneMove(-offsetX, -offsetY, -offsetZ));
+                    }
+                    if (mc.gameSettings.viewSupportMode.value) {
+                        Tessellator t = Tessellator.instance;
+
+                        double x = hitResult.x - offsetX;
+                        double y = hitResult.y - offsetY;
+                        double z = hitResult.z - offsetZ;
+
+                        double oMin = -0.01;
+                        double oMax = 1.01;
+
+                        ISupport sBottom = block.getSupport(world, hitResult.x, hitResult.y, hitResult.z, Side.BOTTOM);
+                        ISupport sTop = block.getSupport(world, hitResult.x, hitResult.y, hitResult.z, Side.TOP);
+                        ISupport sNorth = block.getSupport(world, hitResult.x, hitResult.y, hitResult.z, Side.NORTH);
+                        ISupport sSouth = block.getSupport(world, hitResult.x, hitResult.y, hitResult.z, Side.SOUTH);
+                        ISupport sWest = block.getSupport(world, hitResult.x, hitResult.y, hitResult.z, Side.WEST);
+                        ISupport sEast = block.getSupport(world, hitResult.x, hitResult.y, hitResult.z, Side.EAST);
+
+                        t.startDrawingQuads();
+
+                        {// Top
+                            if (sTop.canSupport(PartialSupport.INSTANCE.center(), Side.BOTTOM)) {
+                                t.setColorRGBA_F(0f, 1f, 0f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0f, 0.25f);
+                            }
+                            t.addVertex(x + oMin + 0.25, y + oMax, z + oMin + 0.25);
+                            t.addVertex(x + oMin + 0.25, y + oMax, z + oMax - 0.25);
+                            t.addVertex(x + oMax - 0.25, y + oMax, z + oMax - 0.25);
+                            t.addVertex(x + oMax - 0.25, y + oMax, z + oMin + 0.25);
+
+                            if (sTop.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM)) {
+                                t.setColorRGBA_F(0.5f, 1f, 0.5f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                            }
+                            t.addVertex(x + oMin, y + oMax, z + oMin);
+                            t.addVertex(x + oMin + 0.25, y + oMax, z + oMin + 0.25);
+                            t.addVertex(x + oMax - 0.25, y + oMax, z + oMin + 0.25);
+                            t.addVertex(x + oMax, y + oMax, z + oMin);
+
+                            if (sTop.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM)) {
+                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                            }
+                            t.addVertex(x + oMin, y + oMax, z + oMax);
+                            t.addVertex(x + oMax, y + oMax, z + oMax);
+                            t.addVertex(x + oMax - 0.25, y + oMax, z + oMax - 0.25);
+                            t.addVertex(x + oMin + 0.25, y + oMax, z + oMax - 0.25);
+
+                            if (sTop.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM)) {
+                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                            }
+                            t.addVertex(x + oMin, y + oMax, z + oMin);
+                            t.addVertex(x + oMin, y + oMax, z + oMax);
+                            t.addVertex(x + oMin + 0.25, y + oMax, z + oMax - 0.25);
+                            t.addVertex(x + oMin + 0.25, y + oMax, z + oMin + 0.25);
+
+                            if (sTop.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM)) {
+                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                            }
+                            t.addVertex(x + oMax, y + oMax, z + oMin);
+                            t.addVertex(x + oMax - 0.25, y + oMax, z + oMin + 0.25);
+                            t.addVertex(x + oMax - 0.25, y + oMax, z + oMax - 0.25);
+                            t.addVertex(x + oMax, y + oMax, z + oMax);
+                        }
+
+                        {// Bottom
+                            if (sBottom.canSupport(PartialSupport.INSTANCE.center(), Side.TOP)) {
+                                t.setColorRGBA_F(0f, 1f, 0f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0f, 0.25f);
+                            }
+                            t.addVertex(x + oMin + 0.25, y + oMin, z + oMin + 0.25);
+                            t.addVertex(x + oMax - 0.25, y + oMin, z + oMin + 0.25);
+                            t.addVertex(x + oMax - 0.25, y + oMin, z + oMax - 0.25);
+                            t.addVertex(x + oMin + 0.25, y + oMin, z + oMax - 0.25);
+
+                            if (sBottom.canSupport(PartialSupport.INSTANCE.up(), Side.TOP)) {
+                                t.setColorRGBA_F(0.5f, 1f, 0.5f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                            }
+                            t.addVertex(x + oMin + 0.25, y + oMin, z + oMax - 0.25);
+                            t.addVertex(x + oMax - 0.25, y + oMin, z + oMax - 0.25);
+                            t.addVertex(x + oMax, y + oMin, z + oMax);
+                            t.addVertex(x + oMin, y + oMin, z + oMax);
+
+                            if (sBottom.canSupport(PartialSupport.INSTANCE.down(), Side.TOP)) {
+                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                            }
+                            t.addVertex(x + oMin + 0.25, y + oMin, z + oMin + 0.25);
+                            t.addVertex(x + oMin, y + oMin, z + oMin);
+                            t.addVertex(x + oMax, y + oMin, z + oMin);
+                            t.addVertex(x + oMax - 0.25, y + oMin, z + oMin + 0.25);
+
+                            if (sBottom.canSupport(PartialSupport.INSTANCE.left(), Side.TOP)) {
+                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                            }
+                            t.addVertex(x + oMax, y + oMin, z + oMin);
+                            t.addVertex(x + oMax, y + oMin, z + oMax);
+                            t.addVertex(x + oMax - 0.25, y + oMin, z + oMax - 0.25);
+                            t.addVertex(x + oMax - 0.25, y + oMin, z + oMin + 0.25);
+
+                            if (sBottom.canSupport(PartialSupport.INSTANCE.right(), Side.TOP)) {
+                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                            }
+                            t.addVertex(x + oMin, y + oMin, z + oMin);
+                            t.addVertex(x + oMin + 0.25, y + oMin, z + oMin + 0.25);
+                            t.addVertex(x + oMin + 0.25, y + oMin, z + oMax - 0.25);
+                            t.addVertex(x + oMin, y + oMin, z + oMax);
+                        }
+
+                        {// North
+                            if (sNorth.canSupport(PartialSupport.INSTANCE.center(), Side.SOUTH)) {
+                                t.setColorRGBA_F(0f, 1f, 0f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0f, 0.25f);
+                            }
+                            t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMin);
+                            t.addVertex(x + oMax - 0.25, y + oMax - 0.25, z + oMin);
+                            t.addVertex(x + oMax - 0.25, y + oMin + 0.25, z + oMin);
+                            t.addVertex(x + oMin + 0.25, y + oMin + 0.25, z + oMin);
+
+                            if (sNorth.canSupport(PartialSupport.INSTANCE.up(), Side.SOUTH)) {
+                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                            }
+                            t.addVertex(x + oMin, y + oMax, z + oMin);
+                            t.addVertex(x + oMax, y + oMax, z + oMin);
+                            t.addVertex(x + oMax - 0.25, y + oMax - 0.25, z + oMin);
+                            t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMin);
+
+                            if (sNorth.canSupport(PartialSupport.INSTANCE.down(), Side.SOUTH)) {
+                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                            }
+                            t.addVertex(x + oMin + 0.25, y + oMin + 0.25, z + oMin);
+                            t.addVertex(x + oMax - 0.25, y + oMin + 0.25, z + oMin);
+                            t.addVertex(x + oMax, y + oMin, z + oMin);
+                            t.addVertex(x + oMin, y + oMin, z + oMin);
+
+                            if (sNorth.canSupport(PartialSupport.INSTANCE.right(), Side.SOUTH)) {
+                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                            }
+                            t.addVertex(x + oMin, y + oMax, z + oMin);
+                            t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMin);
+                            t.addVertex(x + oMin + 0.25, y + oMin + 0.25, z + oMin);
+                            t.addVertex(x + oMin, y + oMin, z + oMin);
+
+                            if (sNorth.canSupport(PartialSupport.INSTANCE.left(), Side.SOUTH)) {
+                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                            }
+                            t.addVertex(x + oMax, y + oMax, z + oMin);
+                            t.addVertex(x + oMax, y + oMin, z + oMin);
+                            t.addVertex(x + oMax - 0.25, y + oMin + 0.25, z + oMin);
+                            t.addVertex(x + oMax - 0.25, y + oMax - 0.25, z + oMin);
+                        }
+
+                        {// South
+                            if (sSouth.canSupport(PartialSupport.INSTANCE.center(), Side.NORTH)) {
+                                t.setColorRGBA_F(0f, 1f, 0f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0f, 0.25f);
+                            }
+                            t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMax);
+                            t.addVertex(x + oMin + 0.25, y + oMin + 0.25, z + oMax);
+                            t.addVertex(x + oMax - 0.25, y + oMin + 0.25, z + oMax);
+                            t.addVertex(x + oMax - 0.25, y + oMax - 0.25, z + oMax);
+
+                            if (sSouth.canSupport(PartialSupport.INSTANCE.up(), Side.NORTH)) {
+                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                            }
+                            t.addVertex(x + oMin, y + oMax, z + oMax);
+                            t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMax);
+                            t.addVertex(x + oMax - 0.25, y + oMax - 0.25, z + oMax);
+                            t.addVertex(x + oMax, y + oMax, z + oMax);
+
+                            if (sSouth.canSupport(PartialSupport.INSTANCE.down(), Side.NORTH)) {
+                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                            }
+                            t.addVertex(x + oMin + 0.25, y + oMin + 0.25, z + oMax);
+                            t.addVertex(x + oMin, y + oMin, z + oMax);
+                            t.addVertex(x + oMax, y + oMin, z + oMax);
+                            t.addVertex(x + oMax - 0.25, y + oMin + 0.25, z + oMax);
+
+                            if (sSouth.canSupport(PartialSupport.INSTANCE.right(), Side.NORTH)) {
+                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                            }
+                            t.addVertex(x + oMax, y + oMax, z + oMax);
+                            t.addVertex(x + oMax - 0.25, y + oMax - 0.25, z + oMax);
+                            t.addVertex(x + oMax - 0.25, y + oMin + 0.25, z + oMax);
+                            t.addVertex(x + oMax, y + oMin, z + oMax);
+
+                            if (sSouth.canSupport(PartialSupport.INSTANCE.left(), Side.NORTH)) {
+                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                            }
+                            t.addVertex(x + oMin, y + oMax, z + oMax);
+                            t.addVertex(x + oMin, y + oMin, z + oMax);
+                            t.addVertex(x + oMin + 0.25, y + oMin + 0.25, z + oMax);
+                            t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMax);
+                        }
+
+                        {// West
+                            if (sWest.canSupport(PartialSupport.INSTANCE.center(), Side.EAST)) {
+                                t.setColorRGBA_F(0f, 1f, 0f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0f, 0.25f);
+                            }
+                            t.addVertex(x + oMin, y + oMax - 0.25, z + oMin + 0.25);
+                            t.addVertex(x + oMin, y + oMin + 0.25, z + oMin + 0.25);
+                            t.addVertex(x + oMin, y + oMin + 0.25, z + oMax - 0.25);
+                            t.addVertex(x + oMin, y + oMax - 0.25, z + oMax - 0.25);
+
+                            if (sWest.canSupport(PartialSupport.INSTANCE.up(), Side.EAST)) {
+                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                            }
+                            t.addVertex(x + oMin, y + oMax, z + oMin);
+                            t.addVertex(x + oMin, y + oMax - 0.25, z + oMin + 0.25);
+                            t.addVertex(x + oMin, y + oMax - 0.25, z + oMax - 0.25);
+                            t.addVertex(x + oMin, y + oMax, z + oMax);
+
+                            if (sWest.canSupport(PartialSupport.INSTANCE.down(), Side.EAST)) {
+                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                            }
+                            t.addVertex(x + oMin, y + oMin, z + oMin);
+                            t.addVertex(x + oMin, y + oMin, z + oMax);
+                            t.addVertex(x + oMin, y + oMin + 0.25, z + oMax - 0.25);
+                            t.addVertex(x + oMin, y + oMin + 0.25, z + oMin + 0.25);
+
+                            if (sWest.canSupport(PartialSupport.INSTANCE.left(), Side.EAST)) {
+                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                            }
+                            t.addVertex(x + oMin, y + oMax, z + oMin);
+                            t.addVertex(x + oMin, y + oMin, z + oMin);
+                            t.addVertex(x + oMin, y + oMin + 0.25, z + oMin + 0.25);
+                            t.addVertex(x + oMin, y + oMax - 0.25, z + oMin + 0.25);
+
+                            if (sWest.canSupport(PartialSupport.INSTANCE.right(), Side.EAST)) {
+                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                            }
+                            t.addVertex(x + oMin, y + oMax - 0.25, z + oMax - 0.25);
+                            t.addVertex(x + oMin, y + oMin + 0.25, z + oMax - 0.25);
+                            t.addVertex(x + oMin, y + oMin, z + oMax);
+                            t.addVertex(x + oMin, y + oMax, z + oMax);
+                        }
+
+                        {// East
+                            if (sEast.canSupport(PartialSupport.INSTANCE.center(), Side.WEST)) {
+                                t.setColorRGBA_F(0f, 1f, 0f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0f, 0.25f);
+                            }
+                            t.addVertex(x + oMax, y + oMax - 0.25, z + oMin + 0.25);
+                            t.addVertex(x + oMax, y + oMax - 0.25, z + oMax - 0.25);
+                            t.addVertex(x + oMax, y + oMin + 0.25, z + oMax - 0.25);
+                            t.addVertex(x + oMax, y + oMin + 0.25, z + oMin + 0.25);
+
+                            if (sEast.canSupport(PartialSupport.INSTANCE.up(), Side.WEST)) {
+                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                            }
+                            t.addVertex(x + oMax, y + oMax, z + oMin);
+                            t.addVertex(x + oMax, y + oMax, z + oMax);
+                            t.addVertex(x + oMax, y + oMax - 0.25, z + oMax - 0.25);
+                            t.addVertex(x + oMax, y + oMax - 0.25, z + oMin + 0.25);
+
+                            if (sEast.canSupport(PartialSupport.INSTANCE.down(), Side.WEST)) {
+                                t.setColorRGBA_F(0f, 1f, 0.5f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                            }
+                            t.addVertex(x + oMax, y + oMin, z + oMin);
+                            t.addVertex(x + oMax, y + oMin + 0.25, z + oMin + 0.25);
+                            t.addVertex(x + oMax, y + oMin + 0.25, z + oMax - 0.25);
+                            t.addVertex(x + oMax, y + oMin, z + oMax);
+
+                            if (sEast.canSupport(PartialSupport.INSTANCE.left(), Side.WEST)) {
+                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                            }
+                            t.addVertex(x + oMax, y + oMax - 0.25, z + oMax - 0.25);
+                            t.addVertex(x + oMax, y + oMax, z + oMax);
+                            t.addVertex(x + oMax, y + oMin, z + oMax);
+                            t.addVertex(x + oMax, y + oMin + 0.25, z + oMax - 0.25);
+
+                            if (sEast.canSupport(PartialSupport.INSTANCE.right(), Side.WEST)) {
+                                t.setColorRGBA_F(0f, 1f, 1f, 0.25f);
+                            } else {
+                                t.setColorRGBA_F(1f, 0f, 1f, 0.25f);
+                            }
+                            t.addVertex(x + oMax, y + oMax, z + oMin);
+                            t.addVertex(x + oMax, y + oMax - 0.25, z + oMin + 0.25);
+                            t.addVertex(x + oMax, y + oMin + 0.25, z + oMin + 0.25);
+                            t.addVertex(x + oMax, y + oMin, z + oMin);
+                        }
+
+                        t.draw();
                     }
                 }
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
index 27ef2c4b5..6a202bb0b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
@@ -323,7 +323,7 @@ public class TextureManager {
         	String string = createErrorString(errors);
         	
         	if(mc.currentScreen != null) {
-                PopupBuilder builder = new PopupBuilder(mc.currentScreen, mc.resolution.getScaledWidthScreenCoords() - 40);
+                PopupBuilder builder = new PopupBuilder(this.mc.currentScreen, mc.resolution.getScaledWidthScreenCoords() - 40);
                 builder.closeOnClickOut(0);
                 builder.closeOnEnter(0);
                 builder.closeOnEsc(0);
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/Tessellator.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/Tessellator.java
index 2afa55e82..e27c23520 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/Tessellator.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/Tessellator.java
@@ -1,8 +1,10 @@
 package net.minecraft.client.render.tessellator;
 
+import org.jetbrains.annotations.NotNull;
+
 public abstract class Tessellator {
 	
-    public static Tessellator instance = new TessellatorStandard(0x200000);
+    public static @NotNull Tessellator instance = new TessellatorStandard(0x200000);
     
     public abstract void draw();
     public abstract void startDrawingQuads();
diff --git a/game/client/src/main/java/net/minecraft/client/util/debug/OpenGLLoggerCallback.java b/game/client/src/main/java/net/minecraft/client/util/debug/OpenGLLoggerCallback.java
index c40b2d017..5a4b7b4c6 100644
--- a/game/client/src/main/java/net/minecraft/client/util/debug/OpenGLLoggerCallback.java
+++ b/game/client/src/main/java/net/minecraft/client/util/debug/OpenGLLoggerCallback.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.util.debug;
 
+import it.unimi.dsi.fastutil.ints.Int2BooleanMap;
+import it.unimi.dsi.fastutil.ints.Int2BooleanOpenHashMap;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.ARBFramebufferObject;
 import org.lwjgl.opengl.GL11;
@@ -11,8 +13,15 @@ import org.slf4j.LoggerFactory;
 
 public class OpenGLLoggerCallback implements GLDebugMessageCallbackI {
     private static final Logger LOGGER = LoggerFactory.getLogger("OpenGL");
+
+    private final Int2BooleanMap didReport = new Int2BooleanOpenHashMap();
     @Override
     public void invoke(int source, int type, int id, int severity, int length, long message, long userParam) {
+        if (type == GL43.GL_DEBUG_TYPE_DEPRECATED_BEHAVIOR) { // Only log deprecated errors once, due to their known reporting frequency, helps not make 100MB+ log files
+            if (didReport.getOrDefault(id, false)) return;
+            didReport.put(id, true);
+            LOGGER.warn("Disabling repeated logging of next error, due to known hyper frequency");
+        }
         String msg = MemoryUtil.memASCII(message, length);
         switch (severity) {
             case GL43.GL_DEBUG_SEVERITY_HIGH: {
diff --git a/game/core/src/main/java/net/minecraft/core/block/Block.java b/game/core/src/main/java/net/minecraft/core/block/Block.java
index 60be1347a..e11b96a93 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Block.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Block.java
@@ -278,7 +278,7 @@ public final class Block<T extends BlockLogic>
     }
 
     @Override
-    public ItemStack getDefaultStack() {
+    public @NotNull ItemStack getDefaultStack() {
         return new ItemStack(this);
     }
 
@@ -428,8 +428,8 @@ public final class Block<T extends BlockLogic>
     }
 
     @Override
-    public void updateTick(World world, int x, int y, int z, Random rand) {
-        logic.updateTick(world, x, y, z, rand);
+    public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick) {
+        logic.updateTick(world, x, y, z, rand, false);
     }
 
     @Override
@@ -570,7 +570,7 @@ public final class Block<T extends BlockLogic>
     }
 
     @Override
-    public ISupport getSupport(World world, int x, int y, int z, Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
         return logic.getSupport(world, x, y, z, side);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
index 845b62197..671421c04 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
@@ -32,9 +32,12 @@ interface BlockInterface {
     @NotNull NamespaceID namespaceId();
 
     boolean isCubeShaped();
+    @Deprecated
     boolean canPlaceOnSurface();
+    @Deprecated
     boolean canPlaceOnSurfaceOnCondition(World world, int x, int y, int z);
     boolean renderAsNormalBlockOnCondition(WorldSource world, int x, int y, int z);
+    @Deprecated
     boolean canPlaceOnSurfaceOfBlock(World world, int x, int y, int z);
     /**
      * Make sure if this gets overridden in a block that {@link net.minecraft.core.block.Block#getBreakResult(World, EnumDropCause, int, TileEntity)} also has a valid method since {@link EntityFallingBlock EntityFallingBlock} uses it!
@@ -58,7 +61,7 @@ interface BlockInterface {
     boolean blocksLight();
     boolean canCollideCheck(int meta, boolean shouldCollideWithFluids);
     boolean isCollidable();
-    void updateTick(World world, int x, int y, int z, Random rand);
+    void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick);
     void animationTick(World world, int x, int y, int z, Random rand);
     void onNeighborBlockChange(World world, int x, int y, int z, int blockId);
     int tickDelay();
@@ -96,7 +99,7 @@ interface BlockInterface {
     boolean getDirectSignal(World world, int x, int y, int z, Side side);
     void harvestBlock(World world, Player player, int x, int y, int z, int meta, TileEntity tileEntity);
     void dropBlockWithCause(World world, EnumDropCause cause, int x, int y, int z, int meta, TileEntity tileEntity, Player player);
-    ISupport getSupport(World world, int x, int y, int z, Side side);
+    @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side);
     boolean canBlockStay(World world, int x, int y, int z);
     void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced);
     void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
index 8c51ac8b7..282862f05 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
@@ -191,7 +191,7 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     }
 
     @Override
-    public void updateTick(World world, int x, int y, int z, Random rand) {
+    public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick) {
 
     }
 
@@ -446,7 +446,7 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     }
 
     @Override
-    public ISupport getSupport(World world, int x, int y, int z, Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
         return FullSupport.INSTANCE;
     }
 
@@ -506,7 +506,7 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     }
 
     @Override
-    public ItemStack getDefaultStack() {
+    public @NotNull ItemStack getDefaultStack() {
         return block.getDefaultStack();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
index c2fe2d02c..c7d4f3bb1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
@@ -89,7 +89,7 @@ public class BlockLogicActivator extends BlockLogicVeryRotatable
     }
 
     @Override
-    public void updateTick(World world, int x, int y, int z, Random rand)
+    public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         useItem(world, x, y, z, rand);
     }
